using System;
using System.IO;
using System.Windows;
using System.Windows.Media;
using System.Windows.Media.Imaging;

namespace TestProject
{
    /// <summary>
    ///  
    /// </summary>
    public partial class MainWindow : Window
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - MainWindow()

        /// <summary>
        /// 
        /// </summary>
        public MainWindow()
        {
            InitializeComponent();

            this.captureButton.Click += captureButton_Click;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region Capture ư Ŭ óϱ - captureButton_Click(sender, e)

        /// <summary>
        /// Capture ư Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void captureButton_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                SaveImage(this.xCanvas        , "d:\\x.png"         );
                SaveImage(this.plusCanvas     , "d:\\plus.png"      );
                SaveImage(this.arrowUpCanvas  , "d:\\arrow_up.png"  );
                SaveImage(this.arrowDownCanvas, "d:\\arrow_down.png");
                SaveImage(this.pencilCanvas   , "d:\\pencil.png"    );

                MessageBox.Show("۾ Ϸ߽ϴ.");
            }
            catch(Exception exception)
            {
                MessageBox.Show(exception.Message);
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Function

        #region ̹ ϱ - SaveImage(element, filePath)

        /// <summary>
        /// ̹ ϱ
        /// </summary>
        /// <param name="element">ӿũ Ʈ</param>
        /// <param name="filePath"> </param>
        private void SaveImage(FrameworkElement element, string filePath)
        {
            Rect rectangle = new Rect(0, 0, element.ActualWidth, element.ActualHeight);

            DrawingVisual visual = new DrawingVisual();

            using(DrawingContext context = visual.RenderOpen())
            {
                VisualBrush brush = new VisualBrush(element);

                context.DrawRectangle(brush, null, new Rect(rectangle.Size));
            }

            int width  = (int)element.ActualWidth;
            int height = (int)element.ActualHeight;

            RenderTargetBitmap bitmap = new RenderTargetBitmap
            (
                width,
                height,
                96,
                96,
                PixelFormats.Pbgra32
            );

            bitmap.Render(visual);

            PngBitmapEncoder encoder = new PngBitmapEncoder();

            encoder.Frames.Add(BitmapFrame.Create(bitmap));

            using(FileStream stream = new FileStream(filePath, FileMode.Create, FileAccess.Write, FileShare.None))
            {
                encoder.Save(stream);
            }
        }

        #endregion
    }
}